/**
 * Manages buffer descriptors.
 */

#ifndef _BUFFER_DESCRIPTOR_MANAGER_H_
#define _BUFFER_DESCRIPTOR_MANAGER_H_

#include <xdc/std.h>
#include <ti/xdais/dm/xdm.h>

typedef void* BufferDescriptorManagerHandle;

extern BufferDescriptorManagerHandle BufferDescriptorManager_create(int buffersCount, XDAS_Int32 numberOfDescriptorBuffers, XDAS_Int32* bufferSizes);
extern void BufferDescriptorManager_delete(BufferDescriptorManagerHandle manager);

extern XDM_BufDesc* BufferDescriptorManager_getUnusedBufferDescriptor(BufferDescriptorManagerHandle manager, XDAS_Int32 bufferDescriptorId);
extern XDAS_Int32 BufferDescriptorManager_releaseBufferDescriptor(BufferDescriptorManagerHandle manager, XDAS_Int32 bufferDescriptorId);
extern XDM_BufDesc* BufferDescriptorManager_getBufferDescriptorById(BufferDescriptorManagerHandle manager, XDAS_Int32 bufferDescriptorId);
extern int BufferDescriptorManager_referenceBufferDescriptorById(BufferDescriptorManagerHandle manager, XDAS_Int32 bufferDescriptorId);

#endif
