/**
 * Common definitions of master and slave decode tasks.
 */

#pragma once

#include "Heaps.h"
#include "Configuration.h"

#include <ti/xdais/dm/xdm.h>
#include <ti/xdais/dm/ividdec2.h>

#pragma STRUCT_ALIGN(SharedDecoderData, L2_CACHE_LINE_SIZE)

typedef struct {
    IVIDDEC2_InArgs inArguments;
    int extraInArgumentsData[8];
    XDM1_SingleBufDesc inBufferDescriptor;
    XDAS_Int8* outBuffer_bufs[3];
    XDAS_Int32 outBuffer_bufSizes[3];
} SharedDecoderData;

extern SharedDecoderData sharedDecodersData[MAX_DECODERS_PER_DSP];
