/**
 * Decoder interface.
 */

#pragma once

#include <xdc/std.h>
#include <ti/xdais/dm/ividdec2.h>

#include "AlgorithmUtils.h"
#include "Common.h"

typedef struct {
    int sarWidth;
    int sarHeight;
} AspectRatio;

typedef struct Decoder {
    IVIDDEC2_Handle handle;
    IVIDDEC2_Fxns* functions;
    IVIDDEC2_InArgs* inArguments;
    IVIDDEC2_OutArgs* outArguments;
    IVIDDEC2_Status* status;
    IVIDDEC2_Params* params;
    IVIDDEC2_DynamicParams* dynamicParams;
    IALG_MemRec memTabs[MAX_MEM_RECS];
    int decodersCount;
    int decoderTaskIndex;
    int algorithmIndex;

    void (*swbarr)(int32_t algorithmIndex, uint32_t swbarr_cnt);
    void (*activate)(struct Decoder* decoder);
    void (*deactivate)(struct Decoder* decoder);
    void (*delete)(struct Decoder* decoder);
} Decoder;
