/**
 * Encoder interfaces.
 */

#pragma once

#include <xdc/std.h>
#include <ti/xdais/dm/ividenc.h>
#include <ti/xdais/dm/ividenc2.h>

#include "AlgorithmUtils.h"

#include "Decoder.h"
#include "Common.h"

typedef struct Encoder2 {
    IVIDENC2_Handle handle;
    IVIDENC2_Fxns* functions;
    IVIDENC2_InArgs* inArguments;
    IVIDENC2_OutArgs* outArguments;
    IVIDENC2_Status* status;
    IVIDENC2_Params* params;
    IVIDENC2_DynamicParams* dynamicParams;
    IALG_MemRec memTabs[MAX_MEM_RECS];
    int encodersCount;
    int encoderTaskIndex;
    int algorithmIndex;

    void (*swbarr)(int32_t algorithmIndex, uint32_t swbarr_cnt);
    int32_t (*shmmap_sync)(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);
    void (*activate)(struct Encoder2* encoder);
    void (*deactivate)(struct Encoder2* encoder);
    void (*delete)(struct Encoder2* encoder);
} Encoder2;
