/**
 * Multicore API for algorithms (i.e. decoders and encoders).
 */

#include <ti/sdo/codecs/h264hpvdec/ividmc3.h>

extern int MulticoreApi_activeAlgorithm;

#ifndef IVIDMC_SHMEM_KEY_CLEAN
#define IVIDMC_SHMEM_KEY_CLEAN (0xFFFF)
#endif

inline void MulticoreApi_setActiveAlgorithm(int algorithmIndex)
{
    MulticoreApi_activeAlgorithm = algorithmIndex;
}

void MulticoreApi_swbarrWithYield(int32_t algorithmIndex, uint32_t swbarr_cnt);
extern void MulticoreApi_swbarr(int32_t coreID, int32_t swbarr_id, uint32_t swbarr_cnt);
extern int32_t* MulticoreApi_shmmap(int32_t coreID, int32_t shmem_key, int32_t shmem_size, uint32_t attr, int32_t alignment);
extern int32_t MulticoreApi_shmmunmap(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);
extern int32_t MulticoreApi_shmmap_sync(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);

extern void MulticoreApi_swbarrDummy(int32_t coreID, int32_t swbarr_id, uint32_t swbarr_cnt);
extern void MulticoreApi_swbarrWithYieldDummy(int32_t algorithmIndex, uint32_t swbarr_cnt);
extern int32_t* MulticoreApi_shmmapDummy(int32_t coreID, int32_t shmem_key, int32_t shmem_size, uint32_t attr, int32_t alignment);
extern int32_t MulticoreApi_shmmunmapDummy(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);
extern int32_t MulticoreApi_shmmap_syncDummy(int32_t coreID, int32_t shmem_key, int32_t *shmem_base);

extern void* MulticoreApi3_keyCreate(uint8_t *name, int32_t user_id, IVIDMC3_KEY_SPACE_e key_space, int32_t num_users, int32_t* user_ids, IVIDMC3_KeyCfg_t *cfg);
extern int32_t MulticoreApi3_lockAcquire(int32_t user_id, void* lockHandle);
extern int32_t MulticoreApi3_lockRelease(int32_t user_id, void* lockHandle);
extern int32_t MulticoreApi3_lockCheck(int32_t user_id, void* lockHandle);
extern int32_t MulticoreApi3_barrWait(int32_t user_id, void* barrHandle);

extern int32_t* MulticoreApi3_shmMap(int32_t user_id, void* shmemHandle);
extern int32_t MulticoreApi3_shmSync(int32_t user_id, void* shmemHandle, int32_t* shmem_base, int32_t shmem_size, uint32_t shmem_sync_attribs);
extern int32_t MulticoreApi3_shmSyncWait(int32_t user_id, void* shmemHandle, int32_t* shmem_transid);

